xfs/029: filter out "extended-header: cycle: 1" from output
[xfstests-dev.git] / tests / xfs / 085
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 085
6 #
7 # Create and populate an XFS filesystem, corrupt a superblock, then see how
8 # the kernel and xfs_repair deal with it.
9 #
10 seq=`basename $0`
11 seqres=$RESULT_DIR/$seq
12 echo "QA output created by $seq"
13
14 here=`pwd`
15 tmp=/tmp/$$
16 status=1        # failure is the default!
17 trap "_cleanup; exit \$status" 0 1 2 3 15
18
19 _cleanup()
20 {
21     cd /
22     #rm -f $tmp.*
23 }
24
25 # get standard environment, filters and checks
26 . ./common/rc
27 . ./common/filter
28 . ./common/attr
29 . ./common/populate
30
31 # real QA test starts here
32 _supported_fs xfs
33 _supported_os Linux
34
35 _require_scratch
36 test -n "${FORCE_FUZZ}" || _require_scratch_xfs_crc
37 _require_attrs
38 _require_populate_commands
39 _require_xfs_db_blocktrash_z_command
40
41 rm -f $seqres.full
42 TESTDIR="${SCRATCH_MNT}/scratchdir"
43 TESTFILE="${TESTDIR}/testfile"
44
45 echo "+ create scratch fs"
46 _scratch_mkfs_xfs > /dev/null
47
48 echo "+ mount fs image"
49 _scratch_mount
50 blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
51
52 echo "+ make some files"
53 mkdir -p "${TESTDIR}"
54 for x in `seq 1 1024`; do
55         touch "${SCRATCH_MNT}/junk.${x}"
56         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
57         if [ "$x" -gt 512 ] && [ "$((inode % 64))" -eq 0 ]; then
58                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
59                 break
60         fi
61 done
62 for x in `seq 2 64`; do
63         touch "${TESTFILE}.${x}"
64 done
65 inode="$(stat -c '%i' "${TESTFILE}.1")"
66 agcount="$(_xfs_mount_agcount $SCRATCH_MNT)"
67 umount "${SCRATCH_MNT}"
68
69 echo "+ check fs"
70 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
71
72 echo "+ corrupt image"
73 $XFS_IO_PROG -f -c "pwrite -S 0x62 32 4" "${SCRATCH_DEV}" >> $seqres.full
74
75 echo "+ mount image"
76 _try_scratch_mount 2>/dev/null && _fail "mount should not succeed"
77
78 echo "+ repair fs"
79 _scratch_xfs_repair >> $seqres.full 2>&1
80
81 echo "+ mount image (2)"
82 _scratch_mount
83
84 echo "+ chattr -R -i"
85 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
86
87 echo "+ modify files (2)"
88 broken=0
89 for x in `seq 1 64`; do
90         test -e "${TESTFILE}.${x}" || continue
91         echo moo | dd oflag=append conv=notrunc of="${TESTFILE}.${x}" 2>/dev/null
92         test $? -ne 0 && broken=1
93 done
94 echo "broken: ${broken}"
95 umount "${SCRATCH_MNT}"
96
97 echo "+ check fs (2)"
98 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
99
100 status=0
101 exit